from enum import IntEnum
from typing import Any, Callable

class DataItemType(IntEnum):
    PYTHON_OBJECT = ...
    BOOL = ...
    INT = ...
    FLOAT = ...
    STRING = ...
    VEC3_FLOAT = ...
    GYRO_ACCEL_TEMP = ...
    IBUS_CHANNELS = ...

class DataItem:
    @property
    def type(self) -> int: ...

class DataTransform:
    def transform(self, item: DataItem) -> DataItem | None: ...

class LambdaDataTransform(DataTransform):
    def __init__(self, func: Callable[[DataItem], DataItem]) -> None: ...

class GroupDataTransform(DataTransform):
    def __init__(self, transforms: list[DataTransform]) -> None: ...

class PyDataItem(DataItem):
    def __init__(self, value: Any) -> None: ...
    @property
    def value(self) -> Any: ...

class BoolDataItem(DataItem):
    def __init__(self, value: bool) -> None: ...
    @property
    def value(self) -> bool: ...
    @classmethod
    def get_value(cls) -> DataTransform: ...

class IntDataItem(DataItem):
    def __init__(self, value: int) -> None: ...
    @property
    def value(self) -> int: ...
    @classmethod
    def get_value(cls) -> DataTransform: ...

class FloatDataItem(DataItem):
    def __init__(self, value: float) -> None: ...
    @property
    def value(self) -> float: ...
    @classmethod
    def get_value(cls) -> DataTransform: ...

class StrDataItem(DataItem):
    def __init__(self, value: str) -> None: ...
    @property
    def value(self) -> str: ...
    @classmethod
    def get_value(cls) -> DataTransform: ...

class Vec3FloatDataItem(DataItem):
    def __init__(self, x: float, y: float, z: float, mask: int) -> None: ...
    @property
    def value(self) -> tuple[float, float, float, int]: ...
    @classmethod
    def get_x(cls) -> DataTransform: ...
    @classmethod
    def get_y(cls) -> DataTransform: ...
    @classmethod
    def get_z(cls) -> DataTransform: ...

class GyroAccelTempDataItem(DataItem):
    def __init__(
        self, gx: float, gy: float, gz: float, ax: float, ay: float, az: float, temp: float, mask: int
    ) -> None: ...
    @property
    def value(self) -> tuple[float, float, float, float, float, float, float, int]: ...
    @classmethod
    def get_gyro(cls) -> DataTransform: ...
    @classmethod
    def get_accel(cls) -> DataTransform: ...
    @classmethod
    def get_temp(cls) -> DataTransform: ...

class IBusChannelsDataItem(DataItem):
    def __init__(self, value: list[int], is_connected: bool) -> None: ...
    @property
    def value(self) -> list[int]: ...
    @property
    def is_connected(self) -> bool: ...
    @classmethod
    def get_channel(cls, channel: int) -> DataTransform: ...
    @classmethod
    def get_is_connected(cls) -> DataTransform: ...
